package dev.team6;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertThat;
import static org.junit.Assert.assertTrue;

import dev.team6.daos.DataBaseDao;
import dev.team6.daos.DataBaseDaoImpl;
import dev.team6.models.Employee;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;

import dev.team6.daos.TransactionDao;
import dev.team6.daos.TransactionDaoImpl;

import javax.swing.event.CaretListener;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

public class TransactionTest {

    private static final TransactionDao tDao = new TransactionDaoImpl();
    private static final DataBaseDao dDao = new DataBaseDaoImpl();

    @Rule
    public ExpectedException expectedException = ExpectedException.none();

    /*******************************************************************
     * CREATE
     ******************************************************************/

    @Test
    public void testCreateRecord() {
        Employee localEmployeeObject = new Employee("Carlos", "carlos@email.com");

        //Clear table for testing
        dDao.dropTable(localEmployeeObject);

        //update with generated id
        localEmployeeObject.setId(tDao.createRecord(localEmployeeObject));

        //used the findOne() to get employee object based on primary key column 'id'
        Employee remoteEmployeeObject = (Employee) tDao.findOne(localEmployeeObject, "id",localEmployeeObject.getId());

        //test
        assertTrue(tDao.findAll(localEmployeeObject).stream().filter(e -> e.getId() == localEmployeeObject.getId()).findFirst().orElse(null) !=null );
    }

    /*******************************************************************
     * READ
     ******************************************************************/
    @Test
    public <T> void testFindOne() {
        //Create initial employee
        Employee localEmployeeObject = new Employee("Carlos", "carlos@email.com");

        //Clear table for testing
        dDao.dropTable(localEmployeeObject);

        //update with generated id
        localEmployeeObject.setId(tDao.createRecord(localEmployeeObject));

        //used the findOne() to get employee object based on primary key column 'id'
        Employee remoteEmployeeObject = (Employee) tDao.findOne(localEmployeeObject, "id",localEmployeeObject.getId());

        //test
        assertEquals( localEmployeeObject, remoteEmployeeObject);
    }
    @Test
    public <T> void testFindAll() {
        //Creating Employees
        Employee testEmployee1 = new Employee(0,"CarlosOne", "carlos1@email.com");
        Employee testEmployee2 = new Employee(0,"CarlosTwo", "carlos2@email.com");
        Employee testEmployee3 = new Employee(0,"CarlosThree", "carlos3@email.com");

        //dropping table to get a clean view of the database
        dDao.dropTable(testEmployee1);

        //Create the record and update the objects with the generated ids
        testEmployee1.setId(tDao.createRecord(testEmployee1));
        testEmployee2.setId(tDao.createRecord(testEmployee2));
        testEmployee3.setId( tDao.createRecord(testEmployee3));

        //Fetching a list of objects found in the database
        List<Employee> dbEmployeeList = tDao.findAll(testEmployee1);
        //adding all the updated employee objects to an ArrayList to be compared to the one generated by findAll()
        List<Employee> localEmployeeList = new ArrayList<>();
        localEmployeeList.add(testEmployee1);
        localEmployeeList.add(testEmployee2);
        localEmployeeList.add(testEmployee3);

        assertEquals( localEmployeeList, dbEmployeeList);

    }

    /*******************************************************************
     * Update
     ******************************************************************/
    @Test
    public void testUpdate() {
        Employee localEmployeeObject = new Employee("Intentionally Left Blank", "carlos@email.com");

        //Clear table for testing
        dDao.dropTable(localEmployeeObject);

        //update with generated id
        localEmployeeObject.setId(tDao.createRecord(localEmployeeObject));
        //update local object
        localEmployeeObject.setEmployeeName("John Doa");
        //update remote object with a copy of the local object
        tDao.updateByField(localEmployeeObject, "id", localEmployeeObject.getId());
        //fetch remote object
        Employee remoteEmployeeObject = (Employee) tDao.findOne(localEmployeeObject, "id",localEmployeeObject.getId());
        //test
        assertEquals( localEmployeeObject, remoteEmployeeObject);

    }

    @Test
    public void testUpdateCompareOriginal() {
        Employee localEmployeeObject = new Employee("Intentionally Left Blank", "carlos@email.com");

        //Clear table for testing
        dDao.dropTable(localEmployeeObject);
        //update with generated id
        localEmployeeObject.setId(tDao.createRecord(localEmployeeObject));
        Employee originalEmployeeObject = (Employee) tDao.findOne(localEmployeeObject, "id",localEmployeeObject.getId());

        localEmployeeObject.setEmployeeName("John Doa");
        tDao.updateByField(localEmployeeObject, "id", localEmployeeObject.getId());

        Employee updatedEmployeeObject = (Employee) tDao.findOne(localEmployeeObject, "id",localEmployeeObject.getId());
        System.out.println("Original: "  +originalEmployeeObject);
        System.out.println("Updated: " + updatedEmployeeObject);
        //test
        assertFalse(updatedEmployeeObject.equals(originalEmployeeObject));

        System.out.println("Original employeeName= " + originalEmployeeObject.getEmployeeName());
        System.out.println("Updated employeeName= " + updatedEmployeeObject.getEmployeeName());
        assertFalse(updatedEmployeeObject.getEmployeeName().equals(originalEmployeeObject.getEmployeeName()));

    }

    @Test
    public void testUpdateFail() {
        Employee localEmployeeObject = new Employee("Intentionally Left Blank", "carlos@email.com");

        //Clear table for testing
        dDao.dropTable(localEmployeeObject);
        //update with generated id
        localEmployeeObject.setId(tDao.createRecord(localEmployeeObject));
        Employee originalEmployeeObject = (Employee) tDao.findOne(localEmployeeObject, "id",localEmployeeObject.getId());

        localEmployeeObject.setEmployeeName("John Doa");
        //
        tDao.updateByField(localEmployeeObject, "id", -1);

        Employee updatedEmployeeObject = (Employee) tDao.findOne(localEmployeeObject, "id", localEmployeeObject.getId());
        System.out.println("Original: "  +originalEmployeeObject);
        System.out.println("Updated: " + updatedEmployeeObject);
        //test
        assertEquals(originalEmployeeObject, updatedEmployeeObject);


    }

    /*******************************************************************
     * Delete
     ******************************************************************/

    @Test
    public void testDelete() {
        Employee localEmployeeObject = new Employee("Carlos", "carlos@email.com");

        //Clear table for testing
        dDao.dropTable(localEmployeeObject);

        //update with generated id
        localEmployeeObject.setId(tDao.createRecord(localEmployeeObject));

        //if deleted then return true
        boolean deleteSuccess =  tDao.delete(localEmployeeObject, "id", localEmployeeObject.getId());
        //used the findOne() to get employee object based on primary key column 'id'
        Employee remoteEmployeeObject = (Employee) tDao.findOne(localEmployeeObject, "id",localEmployeeObject.getId());

        //if deleted boolean and if the fetch item is null then assert true
        assertTrue(deleteSuccess && (remoteEmployeeObject == null));

    }
}
